/****************************************************************************
 *
 *  Occam two predefined routine numbers
 *
 ****************************************************************************/

/*{{{  copyright*/
/******************************************************************************
*
*  occam 2 compiler
*
*  copyright Inmos Limited 1987
*
******************************************************************************/
/*}}}*/

/*{{{  predefined routines defns.*/

/********************
*   The order of these matters because there are tables built up
*   in the same order
*********************/

#define PD_LONGADD                    0
#define PD_LONGSUM                    1
#define PD_LONGSUB                    2
#define PD_LONGDIFF                   3
#define PD_LONGPROD                   4
#define PD_LONGDIV                    5
#define PD_SHIFTRIGHT                 6
#define PD_SHIFTLEFT                  7
#define PD_NORMALISE                  8
#define PD_FRACMUL                    9
#define PD_ASHIFTRIGHT                10
#define PD_ASHIFTLEFT                 11
#define PD_ROTATERIGHT                12
#define PD_ROTATELEFT                 13
#define PD_CAUSEERROR                 14
#define PD_KERNELRUN                  15
#define PD_LOADINPUTCHANNEL           16
#define PD_LOADOUTPUTCHANNEL          17
#define PD_LOADINPUTCHANNELVECTOR     18
#define PD_LOADOUTPUTCHANNELVECTOR    19
#define PD_LOADBYTEVECTOR             20
#define PD_UNPACKSN                   21
#define PD_ROUNDSN                    22
#define PD_DRAW2D                     23
#define PD_CLIP2D                     24
#define PD_MOVE2D                     25
#define PD_CRCWORD                    26
#define PD_CRCBYTE                    27
#define PD_BITCOUNT                   28
#define PD_BITREVWORD                 29
#define PD_BITREVNBITS                30
#define PD_ABS                        31
#define PD_ISNAN                      32
#define PD_NOTFINITE                  33
#define PD_ORDERED                    34
#define PD_MINUSX                     35
#define PD_MULBY2                     36
#define PD_DIVBY2                     37
#define PD_SQRT                       38
#define PD_FPINT                      39
#define PD_DABS                       40
#define PD_DISNAN                     41
#define PD_DNOTFINITE                 42
#define PD_DORDERED                   43
#define PD_DMINUSX                    44
#define PD_DMULBY2                    45
#define PD_DDIVBY2                    46
#define PD_DSQRT                      47
#define PD_DFPINT                     48
#define PD_SCALEB                     49
#define PD_DSCALEB                    50
#define PD_COPYSIGN                   51
#define PD_DCOPYSIGN                  52
#define PD_NEXTAFTER                  53
#define PD_DNEXTAFTER                 54
#define PD_LOGB                       55
#define PD_DLOGB                      56
#define PD_FLOATINGUNPACK             57
#define PD_DFLOATINGUNPACK            58
#define PD_ARGUMENTREDUCE             59
#define PD_DARGUMENTREDUCE            60
#define PD_REAL32OP                   61
#define PD_REAL64OP                   62
#define PD_IEEE32OP                   63
#define PD_IEEE64OP                   64
#define PD_REAL32REM                  65
#define PD_REAL64REM                  66
#define PD_REAL32EQ                   67
#define PD_REAL64EQ                   68
#define PD_REAL32GT                   69
#define PD_REAL64GT                   70
#define PD_IEEECOMPARE                71
#define PD_DIEEECOMPARE               72
#define PD_IEEE32REM                  73
#define PD_IEEE64REM                  74
#define PD_RESCHEDULE                 75
#define PD_ASSERT                     76 /* added 25/9/90 */
/*}}}*/

/*{{{ Predefines for the configurer */
#define PD_ATTR_LINK                 100
#define PD_ATTR_TYPE                 101
#define PD_ATTR_MEM                  102
#define PD_ATTR_ROMSIZE              103
#define PD_ATTR_ROOT                 104
#define PD_ATTR_ORDERCODE            105
#define PD_ATTR_ORDERVS              106

#define PD_HOSTEDGE                  110
/*}}}*/
